/* $Id: creat2.c,v 1.1 2004/12/04 20:06:30 pho Exp $ */

/* Stress the creat(2) system call */

#include <stdio.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <err.h>

static int stop = 0;

void
handler(int i) {
	stop = 1;
}

int
main(int argc, char **argv) {
	int fd, i, j,  pid;
	char file[128];

	if (argc != 2) {
		fprintf(stderr, "Usage: %s <seconds>\n", argv[0]);
		exit(1);
	}

	i = 10;
	sscanf(argv[1], "%d", &i);
	pid = getpid();

	umask(0);
	signal(SIGALRM, handler);
	alarm((i / 2) + 1);

	for (j = 0; stop == 0; j++) {
		sprintf(file,"p%05d.%05d", pid, j);
		if ((fd = creat(file, 0660)) == -1) 
			err(1, "creat(%s)", file);
		if (close(fd) == -1)
			err(2, "close(%d)", i);

/*		if (j == 500000)
			stop = 1;*/
	}

	for (i = --j; i >= 0; i--) {
		sprintf(file,"p%05d.%05d", pid, i);
		if (unlink(file) == -1)
			err(3, "unlink(%s)", file);
		
	}
	return 0;
}
