#!/bin/sh

# $Id$

export PATH=.:$PATH
prog=libthr

[ $# -eq 1 ] && [ $1 = failsafe ] && failsafe=$1

run () {
   n=$1
   d=`date`
   echo "Starting $n incarnation(s) of $prog at $d"
   i=0
   while [ $i -lt $n ]; do
      i=`expr $i + 1`
      nice -20 $prog $failsafe &
   done
   sleep 1


   while pgrep ${prog} > /dev/null; do
      sleep 60
      d=`date '+%H:%M.%S'`
      top -d1 2>&1 | grep -w $prog | while read l; do
         printf "%8s %s\n" "$d" "$l"
         d=""
      done
   done
   d=`date`
   echo "Done     $n incarnation(s) of $prog at $d"
}

[ `../random/random 1 100` -gt 10 ] && exit
sleep `../random/random 1 10`

run 2 > libthr.log 2>&1
