/* $Id: udp.c,v 1.1 2004/10/16 08:40:14 pho Exp $ */

#include <sys/types.h>
#include <machine/endian.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <sys/time.h>

#include <netinet/in.h>
#include <arpa/inet.h>

#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <err.h>

struct sockaddr_in sock_in;
struct servent *sp;
struct hostent *host;

char		greet[] = "Hello, world!";

void 
udp(void) {
	char *hostname;
	int f;

	bzero((char *)&sock_in, sizeof(sock_in));
	sock_in.sin_family = AF_INET;
	f = socket(AF_INET, SOCK_DGRAM, 0);
/*	f = socket(AF_INET, SOCK_STREAM, 0);*/
	if (f < 0)
		err(1, "socket");
	if (bind(f, (struct sockaddr *)&sock_in, sizeof(sock_in)) < 0) {
/*		warn("bind");*/
		return;
	}
	if (getenv("BLASTHOST") == NULL)
		hostname = "localhost";
	else
		hostname = getenv("BLASTHOST");
	host = gethostbyname(hostname);
	if (host) {
		sock_in.sin_family = host->h_addrtype;
		bcopy(host->h_addr, &sock_in.sin_addr, host->h_length);
	} else {
		sock_in.sin_family = AF_INET;
		sock_in.sin_addr.s_addr = inet_addr(hostname);
		if (sock_in.sin_addr.s_addr == -1) {
			fprintf(stderr, "tcpblast: %s unknown host\n", hostname);
			exit(1);
		}
	}
	sock_in.sin_port = htons(9);

	if (connect(f, (struct sockaddr *)&sock_in, sizeof(sock_in)) < 0)
		err(1, "connect");
	if (write(f, greet, sizeof(greet)) != sizeof(greet))
		err(1, "write");
	close(f);
}
