#!/bin/sh

# $Id: pthread_setconcurrency.sh,v 1.1 2004/09/09 10:38:25 pho Exp $

export PATH=.:$PATH
prog=pthread_setconcurrency
pg=`echo $prog | cut -c 1-19`

[ $# -eq 1 ] && [ $1 = failsafe ] && failsafe=$1

run () {
   n=$1
   d=`date`
   printf "Starting %2d incarnation(s) of %s at %s\n" $n $prog "$d"
   i=0
   while [ $i -lt $n ]; do
      i=`expr $i + 1`
      nice -20 $prog $failsafe &
   done
   sleep 1


   while pgrep ${pg} > /dev/null; do
      sleep 5
      d=`date '+%H:%M.%S'`
      top -d1 2>&1 | grep -w $prog | while read l; do
         printf "%8s %s\n" "$d" "$l"
         d=""
      done
   done
   d=`date`
   printf "Done     %2d incarnation(s) of %s at %s\n" $n $prog "$d"
}

cpus=`sysctl kern.smp.cpus | sed 's/.*: //'`
vcpu=`sysctl kern.threads.virtual_cpu | sed 's/.*: //'`
if [ "$cpus" -eq 1 -a "$vcpu" -eq 1 ]; then
   echo "run sysctl kern.threads.virtual_cpu=\"16\""
   exit
fi

for i in 1 2 4 8 10 12 14 16 18 20 30 40 50; do
   run $i
done
