/* $Id: rw.c,v 1.1 2003/06/12 07:30:26 pho Exp $ */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

int
main(int argc, char **argv) {
	int buf[1024], doWrite, i, index, size, to, r;

	if (argc != 3) {
		fprintf(stderr, "Usage: %s -(r|w) <size>\n", argv[0]);
		return(1);
	}

	if (strcmp(argv[1], "-r") == 0) {
		doWrite = 0;
	} else if (strcmp(argv[1], "-w") == 0) {
		doWrite = 1;
	} else {
		fprintf(stderr, "Usage: %s -(r|w) <size>\n", argv[0]);
		return(1);
	}
	sscanf(argv[2], "%d", &size);
	size = size / sizeof(int);

	index = 0;
	if (doWrite == 1) {
		while (index < size) {
			to = sizeof(buf)/sizeof(int);
			if (to >= size) to = size;
			for (i = 0; i < to; i++)
				buf[i] = index + i;
			index += to;
			r = write(1, buf, to * sizeof(int));
			if (r == -1) {
				perror("rw write");
				exit(1);
			}
		}
	} else {
		while (index < size) {
			to = sizeof(buf)/sizeof(int);
			if (to >= size) to = size;
			r = read(0, buf, to * sizeof(int));
			if (r == -1) {
				perror("rw read");
				exit(1);
			}
			for (i = 0; i < to; i++) {
				if (buf[i] != index + i) {
					fprintf(stderr, "%s, pid %d: expected %d @ %d, got %d\n",
						argv[0], getpid(), index+i, index+i, buf[i]);
					exit(1);
				}
			}
			index += to;
		}
	}
	return 0;
}
