#!/bin/sh

# $Id$

# Add color to the most frequent used addresses found in crash dumps.
#
# First argument is the full input file.
# Second argument is a file that may be a subset of the first file,
# thus limiting the number of colors used in the resulting output file.
# An optional third argument specifies the max. number of colors to use.

colors='
style="color:red"
style="color:blue"
style="color:green"
style="color:orange"
style="color:violet"
style="color:purple"
style="color:aqua"
style="color:fuchsia"
style="color:khaki"
style="color:gold"
style="color:red;background-color:lightgray"
style="color:blue;background-color:lightgray"
style="color:green;background-color:lightgray"
style="color:orange;background-color:lightgray"
style="color:violet;background-color:lightgray"
style="color:purple;background-color:lightgray"
style="color:aqua;background-color:lightgray"
style="color:fuchsia;background-color:lightgray"
style="color:khaki;background-color:lightgray"
style="color:gold;background-color:lightgray"
style="color:red;background-color:lightblue"
style="color:blue;background-color:lightblue"
style="color:green;background-color:lightblue"
style="color:orange;background-color:lightblue"
style="color:violet;background-color:lightblue"
style="color:purple;background-color:lightblue"
style="color:aqua;background-color:lightblue"
style="color:fuchsia;background-color:lightblue"
style="color:khaki;background-color:lightblue"
style="color:gold;background-color:lightblue"'


nbcolors=30
[ $# -lt 2 ] && echo "Usage $0 <filename> <trimmed filename>" && exit
[ $# -eq 3 ] && nbcolors=$3

f=$1
t=$2 # subset of $f
vim -f +"so \$VIMRUNTIME/syntax/2html.vim" +"w /tmp/color$$" +"qa" $f > /dev/null 2>&1


# Pick up selected pids
grep " t " $t | sed 's/.* //' | while read l; do
   n=`grep -c $l /tmp/color$$`
   echo $n $l
done > /tmp/number$$

set $colors
n=0
cat $t | sed  \
        -e 's/[^0-9a-f]/ /g' \
        -e 's/  */ /g' \
        -e 's/ /\
/       'g \
        -e 's/0x//g' | \
        sed -n  '/^[0-9a-f]\{8\}$/p' | sort | uniq -c >> /tmp/number$$
       
	sort -rn /tmp/number$$ | \
	tee /tmp/debug | \
#	head -30 | egrep -v "^ *[12] " | sed 's/.* //' | while read l; do
	head -${nbcolors} | egrep -v "^ *[12] " | sed 's/.* //' | while read l; do
#	echo "number = $l"
#	echo "color = $1"
ed /tmp/color$$ <<EOF
1,\$s#${l}#<font $1>${l}</font>#g
w
q
EOF
shift
done
mv /tmp/color$$  $f.html
rm -f /tmp/number$$

# gvim -f +"syn on" +"so \$VIMRUNTIME/syntax/2html.vim" +"wq" +"q" $f
# vim -f +"so \$VIMRUNTIME/syntax/2html.vim" +"w /tmp/xxxx" +"qa" input
